Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis/3.4/TableFileParser.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis/3.4/TableFileParser.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis/3.4/TableFileParser.cs	(revision 6784)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Collections;
 using System.Collections.Generic;
 using System.Globalization;
@@ -33,5 +34,5 @@
     private readonly char[] POSSIBLE_SEPARATORS = new char[] { ',', ';', '\t' };
     private Tokenizer tokenizer;
-    private List<List<double>> rowValues;
+    private List<List<object>> rowValues;
 
     private int rows;
@@ -47,6 +48,6 @@
     }
 
-    private double[,] values;
-    public double[,] Values {
+    private List<IList> values;
+    public List<IList> Values {
       get {
         return values;
@@ -69,5 +70,5 @@
 
     public TableFileParser() {
-      rowValues = new List<List<double>>();
+      rowValues = new List<List<object>>();
       variableNames = new List<string>();
     }
@@ -75,8 +76,9 @@
     public void Parse(string fileName) {
       NumberFormatInfo numberFormat;
+      DateTimeFormatInfo dateTimeFormatInfo;
       char separator;
-      DetermineFileFormat(fileName, out numberFormat, out separator);
+      DetermineFileFormat(fileName, out numberFormat, out dateTimeFormatInfo, out separator);
       using (StreamReader reader = new StreamReader(fileName)) {
-        tokenizer = new Tokenizer(reader, numberFormat, separator);
+        tokenizer = new Tokenizer(reader, numberFormat, dateTimeFormatInfo, separator);
         // parse the file
         Parse();
@@ -86,18 +88,41 @@
       rows = rowValues.Count;
       columns = rowValues[0].Count;
-      values = new double[rows, columns];
-
-      int rowIndex = 0;
-      int columnIndex = 0;
-      foreach (List<double> row in rowValues) {
-        columnIndex = 0;
-        foreach (double element in row) {
-          values[rowIndex, columnIndex++] = element;
-        }
-        rowIndex++;
-      }
-    }
-
-    private void DetermineFileFormat(string fileName, out NumberFormatInfo numberFormat, out char separator) {
+      values = new List<IList>();
+
+      //create columns
+      for (int col = 0; col < columns; col++) {
+        var types = rowValues.Select(r => r[col]).Where(v => v != null && v as string != string.Empty).Take(10).Select(v => v.GetType());
+        if (!types.Any()) {
+          values.Add(new List<string>());
+          continue;
+        }
+
+        var columnType = types.GroupBy(v => v).OrderBy(v => v.Count()).Last().Key;
+        if (columnType == typeof(double)) values.Add(new List<double>());
+        else if (columnType == typeof(DateTime)) values.Add(new List<DateTime>());
+        else if (columnType == typeof(string)) values.Add(new List<string>());
+        else throw new InvalidOperationException();
+      }
+
+
+
+      //fill with values
+      foreach (List<object> row in rowValues) {
+        int columnIndex = 0;
+        foreach (object element in row) {
+          if (values[columnIndex] is List<double> && !(element is double))
+            values[columnIndex].Add(double.NaN);
+          else if (values[columnIndex] is List<DateTime> && !(element is DateTime))
+            values[columnIndex].Add(DateTime.MinValue);
+          else if (values[columnIndex] is List<string> && !(element is string))
+            values[columnIndex].Add(string.Empty);
+          else
+            values[columnIndex].Add(element);
+          columnIndex++;
+        }
+      }
+    }
+
+    private void DetermineFileFormat(string fileName, out NumberFormatInfo numberFormat, out DateTimeFormatInfo dateTimeFormatInfo, out char separator) {
       using (StreamReader reader = new StreamReader(fileName)) {
         // skip first line
@@ -123,4 +148,5 @@
         if (OccurrencesOf(charCounts, '.') > 10) {
           numberFormat = NumberFormatInfo.InvariantInfo;
+          dateTimeFormatInfo = DateTimeFormatInfo.InvariantInfo;
           separator = POSSIBLE_SEPARATORS
             .Where(c => OccurrencesOf(charCounts, c) > 10)
@@ -139,4 +165,5 @@
             // English format (only integer values) with ',' as separator
             numberFormat = NumberFormatInfo.InvariantInfo;
+            dateTimeFormatInfo = DateTimeFormatInfo.InvariantInfo;
             separator = ',';
           } else {
@@ -144,4 +171,5 @@
             // German format (real values)
             numberFormat = NumberFormatInfo.GetInstance(new CultureInfo("de-DE"));
+            dateTimeFormatInfo = DateTimeFormatInfo.GetInstance(new CultureInfo("de-DE"));
             separator = POSSIBLE_SEPARATORS
               .Except(disallowedSeparators)
@@ -154,4 +182,5 @@
           // no points and no commas => English format
           numberFormat = NumberFormatInfo.InvariantInfo;
+          dateTimeFormatInfo = DateTimeFormatInfo.InvariantInfo;
           separator = POSSIBLE_SEPARATORS
             .Where(c => OccurrencesOf(charCounts, c) > 10)
@@ -169,5 +198,5 @@
     #region tokenizer
     internal enum TokenTypeEnum {
-      NewLine, Separator, String, Double
+      NewLine, Separator, String, Double, DateTime
     }
 
@@ -176,8 +205,10 @@
       public string stringValue;
       public double doubleValue;
+      public DateTime dateTimeValue;
 
       public Token(TokenTypeEnum type, string value) {
         this.type = type;
         stringValue = value;
+        dateTimeValue = DateTime.MinValue;
         doubleValue = 0.0;
       }
@@ -193,4 +224,5 @@
       private List<Token> tokens;
       private NumberFormatInfo numberFormatInfo;
+      private DateTimeFormatInfo dateTimeFormatInfo;
       private char separator;
       private const string INTERNAL_SEPARATOR = "#";
@@ -218,7 +250,8 @@
       }
 
-      public Tokenizer(StreamReader reader, NumberFormatInfo numberFormatInfo, char separator) {
+      public Tokenizer(StreamReader reader, NumberFormatInfo numberFormatInfo, DateTimeFormatInfo dateTimeFormatInfo, char separator) {
         this.reader = reader;
         this.numberFormatInfo = numberFormatInfo;
+        this.dateTimeFormatInfo = dateTimeFormatInfo;
         this.separator = separator;
         separatorToken = new Token(TokenTypeEnum.Separator, INTERNAL_SEPARATOR);
@@ -264,7 +297,10 @@
           token.type = TokenTypeEnum.Double;
           return token;
-        }
-
-        // couldn't parse the token as an int or float number so return a string token
+        } else if (DateTime.TryParse(strToken, dateTimeFormatInfo, DateTimeStyles.None, out token.dateTimeValue)) {
+          token.type = TokenTypeEnum.DateTime;
+          return token;
+        }
+
+        // couldn't parse the token as an int or float number  or datetime value so return a string token
         return token;
       }
@@ -299,31 +335,38 @@
     private void ParseValues() {
       while (tokenizer.HasNext()) {
-        List<double> row = new List<double>();
-        row.Add(NextValue(tokenizer));
-        while (tokenizer.HasNext() && tokenizer.Peek() == tokenizer.SeparatorToken) {
-          Expect(tokenizer.SeparatorToken);
-          row.Add(NextValue(tokenizer));
-        }
-        Expect(tokenizer.NewlineToken);
-        // all rows have to have the same number of values            
-        // the first row defines how many samples are needed
-        if (rowValues.Count > 0 && rowValues[0].Count != row.Count) {
-          Error("The first row of the dataset has " + rowValues[0].Count + " columns." +
-            "\nLine " + tokenizer.CurrentLineNumber + " has " + row.Count + " columns.", "", tokenizer.CurrentLineNumber);
-        }
-        // add the current row to the collection of rows and start a new row
-        rowValues.Add(row);
-        row = new List<double>();
-      }
-    }
-
-    private double NextValue(Tokenizer tokenizer) {
-      if (tokenizer.Peek() == tokenizer.SeparatorToken || tokenizer.Peek() == tokenizer.NewlineToken) return double.NaN;
+        if (tokenizer.Peek() == tokenizer.NewlineToken) {
+          tokenizer.Next();
+        } else {
+          List<object> row = new List<object>();
+          object value = NextValue(tokenizer);
+          row.Add(value);
+          while (tokenizer.HasNext() && tokenizer.Peek() == tokenizer.SeparatorToken) {
+            Expect(tokenizer.SeparatorToken);
+            row.Add(NextValue(tokenizer));
+          }
+          Expect(tokenizer.NewlineToken);
+          // all rows have to have the same number of values            
+          // the first row defines how many samples are needed
+          if (rowValues.Count > 0 && rowValues[0].Count != row.Count) {
+            Error("The first row of the dataset has " + rowValues[0].Count + " columns." +
+                  "\nLine " + tokenizer.CurrentLineNumber + " has " + row.Count + " columns.", "",
+                  tokenizer.CurrentLineNumber);
+          }
+          rowValues.Add(row);
+        }
+      }
+    }
+
+    private object NextValue(Tokenizer tokenizer) {
+      if (tokenizer.Peek() == tokenizer.SeparatorToken || tokenizer.Peek() == tokenizer.NewlineToken) return string.Empty;
       Token current = tokenizer.Next();
-      if (current.type == TokenTypeEnum.Separator || current.type == TokenTypeEnum.String) {
+      if (current.type == TokenTypeEnum.Separator) {
         return double.NaN;
+      } else if (current.type == TokenTypeEnum.String) {
+        return current.stringValue;
       } else if (current.type == TokenTypeEnum.Double) {
-        // just take the value
         return current.doubleValue;
+      } else if (current.type == TokenTypeEnum.DateTime) {
+        return current.dateTimeValue;
       }
       // found an unexpected token => throw error 
@@ -334,24 +377,23 @@
 
     private void ParseVariableNames() {
-      // if the first line doesn't start with a double value then we assume that the
-      // first line contains variable names
-      if (tokenizer.HasNext() && tokenizer.Peek().type != TokenTypeEnum.Double) {
-
-        List<Token> tokens = new List<Token>();
-        Token valueToken;
+      //if first token is double no variables names are given
+      if (tokenizer.Peek().type == TokenTypeEnum.Double) return;
+
+      // the first line must contain variable names
+      List<Token> tokens = new List<Token>();
+      Token valueToken;
+      valueToken = tokenizer.Next();
+      tokens.Add(valueToken);
+      while (tokenizer.HasNext() && tokenizer.Peek() == tokenizer.SeparatorToken) {
+        Expect(tokenizer.SeparatorToken);
         valueToken = tokenizer.Next();
-        tokens.Add(valueToken);
-        while (tokenizer.HasNext() && tokenizer.Peek() == tokenizer.SeparatorToken) {
-          Expect(tokenizer.SeparatorToken);
-          valueToken = tokenizer.Next();
-          if (valueToken != tokenizer.NewlineToken) {
-            tokens.Add(valueToken);
-          }
-        }
         if (valueToken != tokenizer.NewlineToken) {
-          Expect(tokenizer.NewlineToken);
-        }
-        variableNames = tokens.Select(x => x.stringValue.Trim()).ToList();
-      }
+          tokens.Add(valueToken);
+        }
+      }
+      if (valueToken != tokenizer.NewlineToken) {
+        Expect(tokenizer.NewlineToken);
+      }
+      variableNames = tokens.Select(x => x.stringValue.Trim()).ToList();
     }
 
Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis/3.4/Tests/OnlineCalculatorPerformanceTest.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis/3.4/Tests/OnlineCalculatorPerformanceTest.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis/3.4/Tests/OnlineCalculatorPerformanceTest.cs	(revision 6784)
@@ -80,5 +80,5 @@
       watch.Start();
       for (int i = 0; i < Repetitions; i++) {
-        double value = calculateFunc(dataset.GetEnumeratedVariableValues(0), dataset.GetEnumeratedVariableValues(1), out errorState);
+        double value = calculateFunc(dataset.GetDoubleValues("y"), dataset.GetDoubleValues("x0"), out errorState);
       }
       Assert.AreEqual(errorState, OnlineCalculatorError.None);
Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis/3.4/Tests/StatisticCalculatorsTest.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis/3.4/Tests/StatisticCalculatorsTest.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis/3.4/Tests/StatisticCalculatorsTest.cs	(revision 6784)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -124,5 +123,5 @@
         IEnumerable<double> x = from rows in Enumerable.Range(0, n)
                                 select testData[rows, c1] * c1Scale;
-        IEnumerable<double> y = (new List<double>() { 150494407424305.44 })
+        IEnumerable<double> y = (new List<double>() { 150494407424305.47 })
           .Concat(Enumerable.Repeat(150494407424305.47, n - 1));
         double[] xs = x.ToArray();
Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis/3.4/Tests/TableFileParserTest.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis/3.4/Tests/TableFileParserTest.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis/3.4/Tests/TableFileParserTest.cs	(revision 6784)
@@ -21,9 +21,7 @@
 
 using System;
-using System.Collections.Generic;
-using System.Linq;
-using Microsoft.VisualStudio.TestTools.UnitTesting;
 using System.IO;
 using HeuristicLab.Problems.DataAnalysis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
 namespace HeuristicLab.Problems.DataAnalysis_3_4.Tests {
 
@@ -46,5 +44,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3.14);
+        Assert.AreEqual(parser.Values[3][0], 3.14);
       }
       finally {
@@ -68,5 +66,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3.14);
+        Assert.AreEqual(parser.Values[3][0], 3.14);
       }
       finally {
@@ -90,5 +88,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3.14);
+        Assert.AreEqual(parser.Values[3][0], 3.14);
       }
       finally {
@@ -113,5 +111,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3.14);
+        Assert.AreEqual(parser.Values[3][0], 3.14);
       }
       finally {
@@ -135,5 +133,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3);
+        Assert.AreEqual((double)parser.Values[3][0], 3);
       }
       finally {
@@ -157,5 +155,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3);
+        Assert.AreEqual((double)parser.Values[3][0], 3);
       }
       finally {
@@ -179,5 +177,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3);
+        Assert.AreEqual((double)parser.Values[3][0], 3);
       }
       finally {
@@ -202,5 +200,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3);
+        Assert.AreEqual((double)parser.Values[3][0], 3);
       }
       finally {
@@ -225,5 +223,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3.14);
+        Assert.AreEqual((double)parser.Values[3][0], 3.14);
       }
       finally {
@@ -248,5 +246,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3.14);
+        Assert.AreEqual((double)parser.Values[3][0], 3.14);
       }
       finally {
@@ -270,5 +268,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3.14);
+        Assert.AreEqual((double)parser.Values[3][0], 3.14);
       }
       finally {
@@ -292,5 +290,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3.14);
+        Assert.AreEqual((double)parser.Values[3][0], 3.14);
       }
       finally {
@@ -314,5 +312,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3);
+        Assert.AreEqual((double)parser.Values[3][0], 3);
       }
       finally {
@@ -336,5 +334,27 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3);
+        Assert.AreEqual((double)parser.Values[3][0], 3);
+      }
+      finally {
+        File.Delete(tempFileName);
+      }
+    }
+
+    [TestMethod]
+    public void ParseWithEmtpyLines() {
+      string tempFileName = Path.GetTempFileName();
+      WriteToFile(tempFileName,
+"x01\t x02\t x03\t x04" + Environment.NewLine +
+"0\t 0\t 0\t 3" + Environment.NewLine +
+ Environment.NewLine +
+"0\t 0\t 0\t 0" + Environment.NewLine +
+" " + Environment.NewLine +
+"0\t 0\t 0\t 0" + Environment.NewLine +
+"0\t 0\t 0\t 0" + Environment.NewLine + Environment.NewLine);
+      TableFileParser parser = new TableFileParser();
+      try {
+        parser.Parse(tempFileName);
+        Assert.AreEqual(4, parser.Rows);
+        Assert.AreEqual(4, parser.Columns);
       }
       finally {
@@ -358,5 +378,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3.14);
+        Assert.AreEqual((double)parser.Values[3][0], 3.14);
       }
       finally {
@@ -380,5 +400,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3.14);
+        Assert.AreEqual((double)parser.Values[3][0], 3.14);
       }
       finally {
@@ -402,5 +422,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3.14);
+        Assert.AreEqual((double)parser.Values[3][0], 3.14);
       }
       finally {
@@ -424,5 +444,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3.14);
+        Assert.AreEqual((double)parser.Values[3][0], 3.14);
       }
       finally {
@@ -446,5 +466,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3);
+        Assert.AreEqual((double)parser.Values[3][0], 3);
       }
       finally {
@@ -468,5 +488,5 @@
         Assert.AreEqual(6, parser.Rows);
         Assert.AreEqual(4, parser.Columns);
-        Assert.AreEqual(parser.Values[0, 3], 3);
+        Assert.AreEqual((double)parser.Values[3][0], 3);
       }
       finally {
Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/PrinsEncoding.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/PrinsEncoding.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/PrinsEncoding.cs	(revision 6784)
@@ -86,5 +86,5 @@
       V[0] = 0;
       for (int i = 1; i <= cities; i++) {
-        V[i] = int.MaxValue;
+        V[i] = double.MaxValue;
       }
 
